package com.usta;

import org.hibernate.Session;
import org.hibernate.SessionFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.http.MediaType;
import org.springframework.stereotype.Controller;
import org.springframework.stereotype.Repository;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.web.bind.annotation.*;

import java.util.List;

/**
 * Created with IntelliJ IDEA.
 * User: usta
 * Date: 1/8/13
 * Time: 9:19 PM
 * To change this template use File | Settings | File Templates.
 */

@Transactional(readOnly = true)
@Repository  // Spring DAO
@Controller  // Spring MVC Kontrolor
@RequestMapping(value = "/yayinevi/*")
public class YayineviKontrolor {

    @Autowired
    // Session üretici fabrika
    private SessionFactory sessionFactory;

    // O anki Session nesnesini döndürür
    public Session  getSession(){
        return sessionFactory.getCurrentSession();
    }

    @RequestMapping(value = "/kitap",
            method = RequestMethod.POST,
            produces = {MediaType.APPLICATION_JSON_VALUE,MediaType.APPLICATION_XML_VALUE },
            consumes = {MediaType.APPLICATION_JSON_VALUE,MediaType.APPLICATION_XML_VALUE })
    @Transactional(readOnly = false)
    public @ResponseBody Long kitapEkle(@RequestBody Kitap kitap) {

     return (Long)getSession().save(kitap);

    }

    @RequestMapping(value = "/kitap/{id}",
            method = RequestMethod.DELETE)
    @Transactional(readOnly = false)
    public void kitapSil(@PathVariable Long id) {

      getSession().delete(getSession().get(Kitap.class,id));

    }

    @RequestMapping(value = "/kitaplar",produces = {MediaType.APPLICATION_XML_VALUE},method = RequestMethod.GET)
    @ResponseStatus( HttpStatus.OK )
    public @ResponseBody KitapWrapper tumKitaplar() {

        List<Kitap> kitaplar= (List<Kitap>)getSession().createQuery("SELECT k FROM Kitap k").list();

      return new KitapWrapper(kitaplar) ;

    }

    @RequestMapping(value = "/kitap",
            method = RequestMethod.PUT,
            consumes = {MediaType.APPLICATION_JSON_VALUE,MediaType.APPLICATION_XML_VALUE })
    @Transactional(readOnly = false)
    public void kitapDuzenle(@RequestBody Kitap kitap) {
        getSession().saveOrUpdate(kitap);
    }
}
